function [y]=any(x,varargin)
//this function outputs 1 if any of the entry of the input is nonzero or true
// for constant/polynomial or boolean input respectively. In case the input is a 
//matrix, it looks for the optional second argument is present, it checks 
//the input matrix rowwise or columnwise depending on user's choice. Columnwise 
//checking is default.

//allowed inputs are constant, polynomial and boolean scalar/vector/matrix	
//varargin can be of size one only. varargin(1) can be either 'r'/'c'.	//


[lhs,rhs]=argn(0)
if rhs~=1&rhs~=2 then
error('incorrect no. of input arguments to function ''any''.')
end

if typeof(x)~='constant' & typeof(x)~='polynomial'&typeof(x)~='boolean' then
error('Input must be a constant, polynomial or boolean.')
end

if rhs==2 then
if typeof(varargin(1))=='string' then
if varargin(1)~='r'&varargin(1)~='c' then
error('the optional argument to function ''any'' must be either ''r'' or ''c''.')
end
else error('wrong type of optional argument to function ''any''.')
end
end


[lhs,rhs]=argn(0)
[m,n]=size(x)


//check for 1 if input is constant or polynomial and look for %t if
//it is boolean.	//
if typeof(x)=='boolean' then
target=%t
else x=x~=0,target=%t
end

if m>1&n>1 then
//if input is a matrix, check for the presence of optional second argument.
//check the matrix rowwise or columnwise accordingly.	//
if rhs==2 then
  if varargin(1)=='r' then
  sx=x',tflag=1
  else sx=x,tflag=0
  end
else sx=x,tflag=0
end

[rsize,csize]=size(sx)
y=zeros(1,csize)

//parse every column of this matrix and look for the target to set the 
//output accordingly.	//
for col=1:csize
  result=%f
  for row=1:rsize
	if sx(row,col)==target then
	result=%t
	break
	end
  end
  if result==%t then
  y(col)=1
  end
end
if tflag==1 then
y=y'
end

//if input is a vector, look for target in it and set the scalar output 
//depending on the presence of target in the input.	//
else
y=0
for jh=1:m*n
if x(jh)==target then 
y=1,break 
end
end
end

//end of function any	//