.so ../sci.an
.SH NAME
any - any, true/nonzero
.SH CALLING SEQUENCE
.nf
[y]=any(x,varargin)
.fi
.SH PARAMETERS
.TP 10
x
: vector or matrix (constant,polynomial or boolean)
.TP 10
y
:  scalar or vector with entries 0 indicating absense of nonzero (%t)
and 1 otherwise, in case of constant/polynomial (boolean) input.
.SH DESCRIPTION
This function outputs 1 if any of the entry of the input is nonzero or true
 for constant/polynomial or boolean input respectively. In case the input is a 
matrix, it looks for the optional second argument is present, it checks 
the input matrix rowwise or columnwise depending on user's choice. Columnwise 
checking is default.
.SH EXAMPLE
.nf
//boolean input
x=[%f %t  %f;%f %f  %f]
y=any(x(1,:))
y=any(x(2,:))
y=any(x)
y=any(x,'c')
y=any(x,'r')
//constant input
x=bool2s(x)
y=any(x(1,:))
y=any(x(2,:))
y=any(x)
y=any(x,'c')
y=any(x,'r')
.fi
.SH AUTHOR
S. S. K.


