.so ../sci.an
.SH NAME
maxnnz - maximum nonzero.
.SH CALLING SEQUENCE
.nf
[m,n]=maxnnz(A [,flag])
.fi
.SH PARAMETERS
.TP 10
A
: real constant matrix  to be looked in.
.TP 10
flag
:  character string indicates if value or magnitude of the coefficients
is to be looked at. 
.TP 10
m
:  first maximum nonzero entry of R.
.TP 10
n
: index of the first maximum entry of R.
.SH DESCRIPTION
This function gives the entry and the index of that entry which is first nonzero entry
with maximum value (or magnitude, depending on user's choice), in the given input A; 
where A is a real vector or a matrix.	
.SH EXAMPLE
.nf
A=[-5:0];
[m,n]=max(A)
[m,n]=maxnnz(A)
A1=[8 5 -3 13 50 -56  50 -56 21];
[m,n]=maxnnz(A1)
[m,n]=maxnnz(A1,'v')
[m,n]=maxnnz(A1,'m')
.fi
.SH SEE ALSO
minnnz
.SH AUTHOR
S. S. K.


