.so ../sci.an
.SH NAME
minnnz - minimum nonzero.
.SH CALLING SEQUENCE
.nf
[m,n]=minnnz(A [,flag])
.fi
.SH PARAMETERS
.TP 10
A
: real constant matrix  to be looked in.
.TP 10
flag
:  character string indicates if value or magnitude of the coefficients
is to be looked at. 
.TP 10
m
:  first minimum nonzero entry of R.
.TP 10
n
: index of the first minimum entry of R.
.SH DESCRIPTION
This function gives the entry and the index of that entry which is first nonzero entry
with minimum value (or magnitude, depending on user's choice), in the given input A; 
where A is a real vector or a matrix.	
.SH EXAMPLE
.nf
A=[0:5];
[m,n]=min(A)
[m,n]=minnnz(A)
A1=[8 5 -3 13 50 -56  50 -56 21];
[m,n]=minnnz(A1)
[m,n]=minnnz(A1,'v')
[m,n]=minnnz(A1,'m')
.fi
.SH SEE ALSO
minnnz
.SH AUTHOR
S. S. K.


